import { jsxs as J, jsx as i } from "react/jsx-runtime";
import { useFloatingTree as K, useFloatingNodeId as Q, useListItem as V, useFloating as W, offset as X, flip as Y, shift as Z, autoUpdate as $, useClick as O, useRole as ee, useDismiss as te, useListNavigation as se, useTypeahead as oe, useInteractions as ne, useMergeRefs as ie, FloatingNode as re, FloatingList as ae, FloatingPortal as le, FloatingFocusManager as ce, FloatingTree as ue } from "@floating-ui/react";
import fe, { forwardRef as N, useState as f, useRef as v, useContext as de, useEffect as F } from "react";
import { MenuContext as I } from "./MenuContext.js";
const x = (e) => {
  if (typeof e == "string")
    return e;
  if (typeof e == "function")
    return e.displayName || e.name || "Component";
  if (typeof e == "object" && e !== null && "type" in e) {
    const t = e.type;
    if (typeof t == "function" || typeof t == "object")
      return t.displayName || t.name || "Component";
  }
  return "Element";
}, R = N(
  ({
    trigger: e,
    children: t,
    label: b = "Open menu",
    defaultPlacement: M = "bottom-start",
    onOpenChange: s,
    mode: h = "system",
    focusMode: k = "system",
    ...P
  }, w) => {
    const [o, d] = f(!1), [E, j] = f(!1), [c, u] = f(null), m = v([]), p = v([]), T = de(I), n = K(), l = Q(), B = V(), { floatingStyles: L, refs: y, context: r } = W({
      nodeId: l,
      open: o,
      onOpenChange: (a) => {
        d(a), s == null || s(a);
      },
      placement: M,
      strategy: "fixed",
      middleware: [X({ mainAxis: 10 }), Y(), Z()],
      whileElementsMounted: $
    }), A = O(r, {
      event: "mousedown",
      toggle: !0,
      ignoreMouse: !1
    }), D = ee(r, { role: "menu" }), S = te(r, { bubbles: !0 }), _ = se(r, {
      listRef: m,
      activeIndex: c,
      nested: !1,
      onNavigate: u,
      loop: !0
    }), H = oe(r, {
      listRef: p,
      onMatch: o ? u : void 0,
      activeIndex: c
    }), { getReferenceProps: U, getFloatingProps: q, getItemProps: z } = ne([A, D, S, _, H]), g = x(e) === "Button" || x(e) === "ButtonIcon", C = g ? {
      noInternalClick: g,
      focusMode: k,
      mode: h
    } : {}, G = fe.cloneElement(
      e,
      {
        ...C,
        "aria-label": b,
        "data-open": o ? "" : void 0,
        "data-focus-inside": E ? "" : void 0,
        ref: ie([y.setReference, B.ref, w]),
        ...U(
          T.getItemProps({
            ...P
          })
        )
      }
    );
    return F(() => {
      if (!n)
        return;
      function a() {
        d(!1), s == null || s(!1);
      }
      return n.events.on("click", a), () => {
        n.events.off("click", a);
      };
    }, [n, s]), F(() => {
      o && n && n.events.emit("menuopen", { nodeId: l });
    }, [n, o, l]), /* @__PURE__ */ J(re, { id: l, children: [
      G,
      /* @__PURE__ */ i(
        I.Provider,
        {
          value: {
            activeIndex: c,
            setActiveIndex: u,
            getItemProps: z,
            setHasFocusInside: j,
            isOpen: o
          },
          children: /* @__PURE__ */ i(ae, { elementsRef: m, labelsRef: p, children: o && /* @__PURE__ */ i(le, { children: /* @__PURE__ */ i(
            ce,
            {
              context: r,
              modal: !1,
              initialFocus: 0,
              returnFocus: !0,
              children: /* @__PURE__ */ i(
                "div",
                {
                  ref: y.setFloating,
                  className: "rounded-md bg-surface-light p-4 shadow-sm shadow-border-dark outline-none sm:p-2",
                  style: L,
                  ...q(),
                  children: t
                }
              )
            }
          ) }) })
        }
      )
    ] });
  }
), me = N((e, t) => /* @__PURE__ */ i(ue, { children: /* @__PURE__ */ i(R, { ...e, ref: t }) }));
me.displayName = "Menu";
R.displayName = "MenuComponent";
export {
  me as Menu,
  R as MenuComponent
};
