import { jsx as i, jsxs as C } from "react/jsx-runtime";
import { useListItem as I, useFloatingTree as k, useMergeRefs as y } from "@floating-ui/react";
import M from "clsx";
import * as d from "react";
import { MenuContext as v } from "./MenuContext.js";
const F = d.forwardRef(
  ({
    label: o,
    disabled: m,
    icon: s,
    raw: f = !1,
    children: l,
    ignoreClick: a = !1,
    ...e
  }, b) => {
    let c = "";
    const u = d.useContext(v), x = I({ label: m ? null : o }), n = k(), g = y([x.ref, b]);
    return f && l ? /* @__PURE__ */ i(
      "div",
      {
        role: "menuitem",
        ...u.getItemProps({
          onClick(r) {
            var t;
            a || ((t = e.onClick) == null || t.call(e, r), n == null || n.events.emit("click"));
          }
        }),
        children: l
      }
    ) : (s && (c = "pl-2"), /* @__PURE__ */ C(
      "button",
      {
        ...e,
        ref: g,
        role: "menuitem",
        className: "m-0 flex w-full rounded-md border border-transparent bg-none px-2 py-2 text-left text-base outline-none focus:border focus:border-border-medium focus:bg-surface-lighter focus:underline disabled:cursor-not-allowed disabled:text-copy-medium sm:py-1",
        tabIndex: 0,
        disabled: m,
        ...u.getItemProps({
          onClick(r) {
            var t;
            a || ((t = e.onClick) == null || t.call(e, r), n == null || n.events.emit("click"));
          },
          onFocus(r) {
            var t;
            (t = e.onFocus) == null || t.call(e, r), u.setHasFocusInside(!0);
          }
        }),
        children: [
          s,
          o && /* @__PURE__ */ i("span", { className: c, children: o })
        ]
      }
    ));
  }
);
F.displayName = "MenuItem";
const j = ({ className: o, ...m }) => {
  const s = M(o, "my-1 border-t border-border-medium");
  return /* @__PURE__ */ i("div", { className: s, ...m });
};
export {
  F as MenuItem,
  j as MenuSeparator
};
